{
  This file was automatically generated on 2016-09-08.

  Delphi/Lazarus Bindings Version 2.1.12

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletRealTimeClock;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_REAL_TIME_CLOCK_DEVICE_IDENTIFIER = 268;
  BRICKLET_REAL_TIME_CLOCK_DEVICE_DISPLAY_NAME = 'Real-Time Clock Bricklet';

  BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME = 1;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME = 2;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_TIMESTAMP = 3;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_OFFSET = 4;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_OFFSET = 5;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD = 6;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD = 7;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_ALARM = 8;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_ALARM = 9;
  BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_REAL_TIME_CLOCK_CALLBACK_DATE_TIME = 10;
  BRICKLET_REAL_TIME_CLOCK_CALLBACK_ALARM = 11;

  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_MONDAY = 1;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_TUESDAY = 2;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_WEDNESDAY = 3;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_THURSDAY = 4;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_FRIDAY = 5;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_SATURDAY = 6;
  BRICKLET_REAL_TIME_CLOCK_WEEKDAY_SUNDAY = 7;
  BRICKLET_REAL_TIME_CLOCK_ALARM_MATCH_DISABLED = -1;
  BRICKLET_REAL_TIME_CLOCK_ALARM_INTERVAL_DISABLED = -1;

type
  TArray0To2OfUInt8 = array [0..2] of byte;

  TBrickletRealTimeClock = class;
  TBrickletRealTimeClockNotifyDateTime = procedure(sender: TBrickletRealTimeClock; const year: word; const month: byte; const day: byte; const hour: byte; const minute: byte; const second: byte; const centisecond: byte; const weekday: byte; const timestamp: int64) of object;
  TBrickletRealTimeClockNotifyAlarm = procedure(sender: TBrickletRealTimeClock; const year: word; const month: byte; const day: byte; const hour: byte; const minute: byte; const second: byte; const centisecond: byte; const weekday: byte; const timestamp: int64) of object;

  /// <summary>
  ///  Battery-backed real-time clock
  /// </summary>
  TBrickletRealTimeClock = class(TDevice)
  private
    dateTimeCallback: TBrickletRealTimeClockNotifyDateTime;
    alarmCallback: TBrickletRealTimeClockNotifyAlarm;
  protected
    procedure CallbackWrapperDateTime(const packet: TByteArray); virtual;
    procedure CallbackWrapperAlarm(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the current date (including weekday) and the current time with hundredths
    ///  of a second resolution.
    ///  
    ///  Possible value ranges:
    ///  
    ///  * Year: 2000 to 2099
    ///  * Month: 1 to 12 (January to December)
    ///  * Day: 1 to 31
    ///  * Hour: 0 to 23
    ///  * Minute: 0 to 59
    ///  * Second: 0 to 59
    ///  * Centisecond: 0 to 99
    ///  * Weekday: 1 to 7 (Monday to Sunday)
    ///  
    ///  If the backup battery is installed then the real-time clock keeps date and
    ///  time even if the Bricklet is not powered by a Brick.
    ///  
    ///  The real-time clock handles leap year and inserts the 29th of February
    ///  accordingly. But leap seconds, time zones and daylight saving time are not
    ///  handled.
    /// </summary>
    procedure SetDateTime(const year: word; const month: byte; const day: byte; const hour: byte; const minute: byte; const second: byte; const centisecond: byte; const weekday: byte); virtual;

    /// <summary>
    ///  Returns the current date (including weekday) and the current time of the
    ///  real-time clock with hundredths of a second resolution.
    /// </summary>
    procedure GetDateTime(out year: word; out month: byte; out day: byte; out hour: byte; out minute: byte; out second: byte; out centisecond: byte; out weekday: byte); virtual;

    /// <summary>
    ///  Returns the current date and the time of the real-time clock converted to
    ///  milliseconds. The timestamp has an effective resolution of hundredths of a
    ///  second.
    /// </summary>
    function GetTimestamp: int64; virtual;

    /// <summary>
    ///  Sets the offset the real-time clock should compensate for in 2.17 ppm steps
    ///  between -277.76 ppm (-128) and +275.59 ppm (127).
    ///  
    ///  The real-time clock time can deviate from the actual time due to the frequency
    ///  deviation of its 32.768 kHz crystal. Even without compensation (factory
    ///  default) the resulting time deviation should be at most ±20 ppm (±52.6
    ///  seconds per month).
    ///  
    ///  This deviation can be calculated by comparing the same duration measured by the
    ///  real-time clock (``rtc_duration``) an accurate reference clock
    ///  (``ref_duration``).
    ///  
    ///  For best results the configured offset should be set to 0 ppm first and then a
    ///  duration of at least 6 hours should be measured.
    ///  
    ///  The new offset (``new_offset``) can be calculated from the currently configured
    ///  offset (``current_offset``) and the measured durations as follow::
    ///  
    ///    new_offset = current_offset - round(1000000 * (rtc_duration - ref_duration) / rtc_duration / 2.17)
    ///  
    ///  If you want to calculate the offset, then we recommend using the calibration
    ///  dialog in Brick Viewer, instead of doing it manually.
    ///  
    ///  The offset is saved in the EEPROM of the Bricklet and only needs to be
    ///  configured once.
    /// </summary>
    procedure SetOffset(const offset: shortint); virtual;

    /// <summary>
    ///  Returns the offset as set by <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.SetOffset"/>.
    /// </summary>
    function GetOffset: shortint; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.DateTime"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.DateTime"/> is only triggered if the date or time changed since the
    ///  last triggering.
    ///  
    ///  The default value is 0.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure SetDateTimeCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.SetDateTimeCallbackPeriod"/>.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    function GetDateTimeCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Configures a repeatable alarm. The <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.Alarm"/> callback is triggered if the
    ///  current date and time matches the configured alarm.
    ///  
    ///  Setting a parameter to -1 means that it should be disabled and doesn't take part
    ///  in the match. Setting all parameters to -1 disables the alarm completely.
    ///  
    ///  For example, to make the alarm trigger every day at 7:30 AM it can be
    ///  configured as (-1, -1, 7, 30, -1, -1, -1). The hour is set to match 7 and the
    ///  minute is set to match 30. The alarm is triggered if all enabled parameters
    ///  match.
    ///  
    ///  The interval has a special role. It allows to make the alarm reconfigure itself.
    ///  This is useful if you need a repeated alarm that cannot be expressed by matching
    ///  the current date and time. For example, to make the alarm trigger every 23
    ///  seconds it can be configured as (-1, -1, -1, -1, -1, -1, 23). Internally the
    ///  Bricklet will take the current date and time, add 23 seconds to it and set the
    ///  result as its alarm. The first alarm will be triggered 23 seconds after the
    ///  call. Because the interval is not -1, the Bricklet will do the same again
    ///  internally, take the current date and time, add 23 seconds to it and set that
    ///  as its alarm. This results in a repeated alarm that triggers every 23 seconds.
    ///  
    ///  The interval can also be used in combination with the other parameters. For
    ///  example, configuring the alarm as (-1, -1, 7, 30, -1, -1, 300) results in an
    ///  alarm that triggers every day at 7:30 AM and is then repeated every 5 minutes.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure SetAlarm(const month: shortint; const day: shortint; const hour: shortint; const minute: shortint; const second: shortint; const weekday: shortint; const interval: longint); virtual;

    /// <summary>
    ///  Returns the alarm configuration as set by <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.SetAlarm"/>.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure GetAlarm(out month: shortint; out day: shortint; out hour: shortint; out minute: shortint; out second: shortint; out weekday: shortint; out interval: longint); virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to, 
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.SetDateTimeCallbackPeriod"/>. The parameters are the same
    ///  as for <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.GetDateTime"/> and <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.GetTimestamp"/> combined.
    ///  
    ///  <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.DateTime"/> is only triggered if the date or time changed since the
    ///  last triggering.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    property OnDateTime: TBrickletRealTimeClockNotifyDateTime read dateTimeCallback write dateTimeCallback;

    /// <summary>
    ///  This callback is triggered every time the current date and time matches the
    ///  configured alarm (see <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.SetAlarm"/>). The parameters are the same
    ///  as for <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.GetDateTime"/> and <see cref="BrickletRealTimeClock.TBrickletRealTimeClock.GetTimestamp"/> combined.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    property OnAlarm: TBrickletRealTimeClockNotifyAlarm read alarmCallback write alarmCallback;
  end;

implementation

constructor TBrickletRealTimeClock.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 1;

  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_TIMESTAMP] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_OFFSET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_OFFSET] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_ALARM] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_ALARM] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_CALLBACK_DATE_TIME] := DEVICE_RESPONSE_EXPECTED_ALWAYS_FALSE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_CALLBACK_ALARM] := DEVICE_RESPONSE_EXPECTED_ALWAYS_FALSE;
  responseExpected[BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_REAL_TIME_CLOCK_CALLBACK_DATE_TIME] := {$ifdef FPC}@{$endif}CallbackWrapperDateTime;
  callbackWrappers[BRICKLET_REAL_TIME_CLOCK_CALLBACK_ALARM] := {$ifdef FPC}@{$endif}CallbackWrapperAlarm;
end;

procedure TBrickletRealTimeClock.SetDateTime(const year: word; const month: byte; const day: byte; const hour: byte; const minute: byte; const second: byte; const centisecond: byte; const weekday: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME, 17);
  LEConvertUInt16To(year, 8, request);
  LEConvertUInt8To(month, 10, request);
  LEConvertUInt8To(day, 11, request);
  LEConvertUInt8To(hour, 12, request);
  LEConvertUInt8To(minute, 13, request);
  LEConvertUInt8To(second, 14, request);
  LEConvertUInt8To(centisecond, 15, request);
  LEConvertUInt8To(weekday, 16, request);
  SendRequest(request);
end;

procedure TBrickletRealTimeClock.GetDateTime(out year: word; out month: byte; out day: byte; out hour: byte; out minute: byte; out second: byte; out centisecond: byte; out weekday: byte);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME, 8);
  response := SendRequest(request);
  year := LEConvertUInt16From(8, response);
  month := LEConvertUInt8From(10, response);
  day := LEConvertUInt8From(11, response);
  hour := LEConvertUInt8From(12, response);
  minute := LEConvertUInt8From(13, response);
  second := LEConvertUInt8From(14, response);
  centisecond := LEConvertUInt8From(15, response);
  weekday := LEConvertUInt8From(16, response);
end;

function TBrickletRealTimeClock.GetTimestamp: int64;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_TIMESTAMP, 8);
  response := SendRequest(request);
  result := LEConvertInt64From(8, response);
end;

procedure TBrickletRealTimeClock.SetOffset(const offset: shortint);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_OFFSET, 9);
  LEConvertInt8To(offset, 8, request);
  SendRequest(request);
end;

function TBrickletRealTimeClock.GetOffset: shortint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_OFFSET, 8);
  response := SendRequest(request);
  result := LEConvertInt8From(8, response);
end;

procedure TBrickletRealTimeClock.SetDateTimeCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request);
end;

function TBrickletRealTimeClock.GetDateTimeCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRealTimeClock.SetAlarm(const month: shortint; const day: shortint; const hour: shortint; const minute: shortint; const second: shortint; const weekday: shortint; const interval: longint);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_SET_ALARM, 18);
  LEConvertInt8To(month, 8, request);
  LEConvertInt8To(day, 9, request);
  LEConvertInt8To(hour, 10, request);
  LEConvertInt8To(minute, 11, request);
  LEConvertInt8To(second, 12, request);
  LEConvertInt8To(weekday, 13, request);
  LEConvertInt32To(interval, 14, request);
  SendRequest(request);
end;

procedure TBrickletRealTimeClock.GetAlarm(out month: shortint; out day: shortint; out hour: shortint; out minute: shortint; out second: shortint; out weekday: shortint; out interval: longint);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_ALARM, 8);
  response := SendRequest(request);
  month := LEConvertInt8From(8, response);
  day := LEConvertInt8From(9, response);
  hour := LEConvertInt8From(10, response);
  minute := LEConvertInt8From(11, response);
  second := LEConvertInt8From(12, response);
  weekday := LEConvertInt8From(13, response);
  interval := LEConvertInt32From(14, response);
end;

procedure TBrickletRealTimeClock.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_REAL_TIME_CLOCK_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRealTimeClock.CallbackWrapperDateTime(const packet: TByteArray);
var year: word; month: byte; day: byte; hour: byte; minute: byte; second: byte; centisecond: byte; weekday: byte; timestamp: int64;
begin
  if (Assigned(dateTimeCallback)) then begin
    year := LEConvertUInt16From(8, packet);
    month := LEConvertUInt8From(10, packet);
    day := LEConvertUInt8From(11, packet);
    hour := LEConvertUInt8From(12, packet);
    minute := LEConvertUInt8From(13, packet);
    second := LEConvertUInt8From(14, packet);
    centisecond := LEConvertUInt8From(15, packet);
    weekday := LEConvertUInt8From(16, packet);
    timestamp := LEConvertInt64From(17, packet);
    dateTimeCallback(self, year, month, day, hour, minute, second, centisecond, weekday, timestamp);
  end;
end;

procedure TBrickletRealTimeClock.CallbackWrapperAlarm(const packet: TByteArray);
var year: word; month: byte; day: byte; hour: byte; minute: byte; second: byte; centisecond: byte; weekday: byte; timestamp: int64;
begin
  if (Assigned(alarmCallback)) then begin
    year := LEConvertUInt16From(8, packet);
    month := LEConvertUInt8From(10, packet);
    day := LEConvertUInt8From(11, packet);
    hour := LEConvertUInt8From(12, packet);
    minute := LEConvertUInt8From(13, packet);
    second := LEConvertUInt8From(14, packet);
    centisecond := LEConvertUInt8From(15, packet);
    weekday := LEConvertUInt8From(16, packet);
    timestamp := LEConvertInt64From(17, packet);
    alarmCallback(self, year, month, day, hour, minute, second, centisecond, weekday, timestamp);
  end;
end;

end.
